
; Public Domain

%include "lmacros3.mac"
%include "eld.mac"

		; ELD executable header
	istruc ELD_HEADER
at eldhSignature,	db "ELD0"
			db 0,0,0
			db 26
at eldhCodeOffset,	dd code
at eldhCodeImageLength,	dw code_size
at eldhCodeAllocLength,	dw 0
at eldhDataOffset,	dd data
at eldhDataImageLength,	dw data_size
at eldhDataAllocLength,	dw 0
at eldhCodeEntrypoint,	dw code_entry - code
at eldhReserved
	iend


	align 16, db 0
code:
		; ELD instance header
	istruc ELD_INSTANCE
at eldiStartCode
at eldiEndCode
at eldiStartData
at eldiEndData
at eldiIdentifier		; (NUL = free space, reclaimable)
	iend

code_entry:
	retf

	align 16
code_size equ $ - code

data:
	dw 26h, 38h, 42h, 0

	align 16, db 0
data_size equ $ - data
